package com.ctg.ag.sdk.core;

package ..deTemp.1736055172626;

import com.ctg.ag.sdk.core.model.ApiCallBack;
import com.ctg.ag.sdk.core.model.BaseApiRequest;
import com.ctg.ag.sdk.core.model.BaseApiResponse;
import com.ctg.ag.sdk.core.model.BuilderParams;
import java.io.Closeable;
import java.io.IOException;
import java.util.concurrent.Future;

public abstract class HttpClient implements Closeable {
  public HttpClient(BuilderParams builderParams) {
    init(builderParams);
  }
  
  protected abstract void init(BuilderParams paramBuilderParams);
  
  public abstract BaseApiResponse syncInvoke(BaseApiRequest paramBaseApiRequest) throws IOException;
  
  public abstract <REQ extends BaseApiRequest, RESP extends BaseApiResponse> Future<RESP> asyncInvoke(REQ paramREQ, ApiCallBack<REQ, RESP> paramApiCallBack);
  
  public abstract void shutdown();
  
  public void close() throws IOException {
    shutdown();
  }
}
